Attribute VB_Name = "Module2"
' Tamao mximo de las cadenas tanto de entrada como de salida.
Const ANA_MAX_CADENA = 1024

' Tipo de datos que simula un string acabado en cero de C
Public Type TipoCadena
    C(1 To ANA_MAX_CADENA) As Byte
End Type

' Definicin de tipos de datos.
Public Const ANA_TIPO_NUMERO As Byte = 1
Public Const ANA_TIPO_TEXTO As Byte = 2

' Definicin de errores.
' **** Errores sintcticos
Public Const ANA_ERROR_NOERROR As Long = 0             ' No hay error.
Public Const ANA_ERROR_NOOPERADOR As Long = 100       ' Se esperaba un operador.
Public Const ANA_ERROR_NONUMERICO As Long = 200       ' Se esperaba un valor numrico.
Public Const ANA_ERROR_NOPARENTESIS As Long = 300     ' Se esperaba un parntesis cerrado.
Public Const ANA_ERROR_NOCIERREFUNCION As Long = 400  ' Se esperaba un parntesis de cierre de funcin.
Public Const ANA_ERROR_NOOPERANDO As Long = 500       ' Se esperaba un operando.
Public Const ANA_ERROR_NOSEPARADOR As Long = 600      ' Se esperaba un separador de listas ; .
Public Const ANA_ERROR_TIPOOPERANDOS As Long = 700    ' Los operandos son de distinto tipo.
Public Const ANA_ERROR_CARACTERNOVALIDO = 800         'Se ha encontrado un carcter no valido.
' Estos dos ltimos valores deben ser activados por el programador en las
' funciones TPedirVariable y TPedirFuncion.
Public Const ANA_ERROR_NOVARIABLE As Long = 1000       ' No es una variable vlida.
Public Const ANA_ERROR_NOFUNCION As Long = 1100        ' No es una funcin vlida.
' **** Errores semnticos
Public Const ANA_ERROR_DIVISION As Long = 1200         ' Se ha producido una divisin por cero.


'  Estructura del bloque de datos.
Public Type BLOQUEDEDATOS
    Numero As Double
    Texto As TipoCadena
    Tipo As Byte
    Error As Long
    PosError As Long
End Type

' Tipo de datos que representra los parmetros que recibir una funcin. Si se prevee la utilizacin de ms
' de 10 parmetros, se ha de redimensionar este tipo al valor adecuado.
Public Type TipoParametros
    P(1 To 10) As BLOQUEDEDATOS
End Type

'Se reservan 2088 bytes que usar la DLL internamente.
Public Type ANADATOSDECONTEXTO
    Nada(1 To 2088) As Byte
End Type

Public Declare Sub A_Inicializar Lib "Analizador.dll" (D As ANADATOSDECONTEXTO)
Public Declare Sub A_AsignarAlPedir Lib "Analizador.dll" (D As ANADATOSDECONTEXTO, ByVal Pv As Long, ByVal Pf As Long)
Public Declare Sub A_AsignarSeparadores Lib "Analizador.dll" (D As ANADATOSDECONTEXTO, Sm As Byte, Sd As Byte)
Public Declare Function A_Analizar Lib "Analizador.dll" (D As ANADATOSDECONTEXTO, ByVal Cadena As String) As BLOQUEDEDATOS
' Funcin que convierte un dato de tipo TipoCadena (string acabado en cero) a un tipo String.
Public Function ConvertirDesdeCadena(C As TipoCadena) As String
    S = ""
    For i = 1 To ANA_MAX_CADENA
        If C.C(i) <> 0 Then
            S = S + Chr(C.C(i))
        Else
            Exit For
        End If
    Next i
    
    ConvertirDesdeCadena = S
End Function

Public Sub ConvertirACadena(S As String, C As TipoCadena)
    j = 1
    L = Len(S)
    If L >= ANA_MAX_CADENA Then
        L = ANA_MAX_CADENA - 1
    End If
    
    For i = 1 To Len(S)
        C.C(j) = Asc(Mid$(S, i, 1))
        j = j + 1
    Next i
    C.C(j) = 0
End Sub


