unit pa;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Analizador;

type
  TForm1 = class(TForm)
    Label2: TLabel;
    Label3: TLabel;
    Expresion: TEdit;
    Resultado: TEdit;
    Button1: TButton;
    Label1: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure PedirVariable(var Variable: TipoCadena; var R: BLOQUEDEDATOS) ;stdcall
begin
     if stricomp(@Variable, 'Euro')=0 then
     begin
        R.Numero:=166.386;
        R.Tipo:=ANA_TIPO_NUMERO;
     end
     else if stricomp(@Variable, 'Pesetas')=0 then
     begin
          R.Numero:=1/166.386;
          R.Tipo:=ANA_TIPO_NUMERO;
     end
     else if stricomp(@Variable, 'Hora')=0 then
     begin
          StrPCopy(@R.Texto, TimeToStr(Time()));
          R.Tipo:=ANA_TIPO_TEXTO;
     end
     else if stricomp(@Variable, 'Fecha')=0 then
     begin
          StrPCopy(@R.Texto, DateToStr(Date()));
          R.Tipo:=ANA_TIPO_TEXTO;
     end
     else
          R.Error:=ANA_ERROR_NOVARIABLE;
end;

procedure PedirFuncion(var Funcion: TipoCadena;
    var Parametros: TipoParametros; N: LongInt; var R: BLOQUEDEDATOS) ;stdcall;
begin
     if (stricomp(@Funcion, 'RAIZ') = 0) and (N = 1) then
     begin
        R.Tipo := ANA_TIPO_NUMERO;
        R.Numero := sqrt(Parametros[1].Numero);
     end
     else if (stricomp(@Funcion, 'SENO') = 0) and (N = 1) then
     begin
          R.Tipo := ANA_TIPO_NUMERO;
          R.Numero := sin(Parametros[1].Numero);
     end
     else if (stricomp(@Funcion, 'SI') = 0) and (N = 3) then
     begin
          if Parametros[1].Tipo <> ANA_TIPO_NUMERO then
          begin
            R.Error := ANA_ERROR_TIPOOPERANDOS;
            exit;
          end;
          if Parametros[1].Numero = 0 then
            R := Parametros[3]
          else
            R := Parametros[2];
     end
     else
          R.Error:=ANA_ERROR_NOFUNCION;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
   D: ANADATOSDECONTEXTO;
   R: BLOQUEDEDATOS;
   S: TipoCadena;
   S1: String;
begin
     Resultado.Text:='';

     A_Inicializar(D);

     A_AsignarAlPedir(D, @PedirVariable, @PedirFuncion);

     StrPCopy(@S, string(Expresion.Text));

     R:=A_Analizar(D, S);

     if R.Error<>ANA_ERROR_NOERROR then
     begin
        case R.Error of
            ANA_ERROR_NOOPERADOR:
                S1:='Error: Se esperaba un operador en la posicin '+
                   IntToStr(R.PosError);
            ANA_ERROR_NONUMERICO:
                S1:='Error: Se ha encontrado un valor que no puede ser evaluado como una expresin numrica en la posicin '+
                   IntToStr(R.PosError);
            ANA_ERROR_NOPARENTESIS:
                S1:='Error: Se esperaba un parntesis en la posicin '+
                   IntToStr(R.PosError);
            ANA_ERROR_NOCIERREFUNCION:
                S1:='Error: Se esperaba un parntesis de cierre de funcin en la posicin '+
                   IntToStr(R.PosError);
            ANA_ERROR_NOOPERANDO:
                S1:='Error: Se esperaba un operando en la posicin '+
                   IntToStr(R.PosError);
            ANA_ERROR_NOSEPARADOR:
                S1:='Error: Se esperaba un separador de lista en la posicin '+
                   IntToStr(R.PosError);
            ANA_ERROR_NOVARIABLE:
                S1:='Error: Se esperaba una variable en la posicin '+
                   IntToStr(R.PosError);
            ANA_ERROR_NOFUNCION:
                S1:='Error: Se esperaba una funcin en la posicin '+
                   IntToStr(R.PosError);
            ANA_ERROR_TIPOOPERANDOS:
                S1:='Error: Los operandos no son compatibles en la posicin '+
                   IntToStr(R.PosError);
            ANA_ERROR_DIVISION:
                S1:='Error: Error de divisin en la posicin '+
                   IntToStr(R.PosError);
	    ANA_ERROR_CARACTERNOVALIDO:
		S1:='Carcter no valido encontrado en la posicin '+
                   IntToStr(R.PosError);
            else
                S1:='Error: Error no definido en la posicion '+
                   IntToStr(R.PosError);
        end;
        StrPCopy(@S, S1);
        Application.MessageBox(@S, 'Error', mb_OK);
        exit;
     end;

     if R.Tipo=ANA_TIPO_NUMERO then
     begin
          Str(R.Numero, S1);
          Resultado.Text:=S1;
     end
     else
     begin
          Resultado.Text:=R.Texto;
     end;
end;

end.
