//---------------------------------------------------------------------------
#ifndef ParserH
#define ParserH

#include <windows.h>

// Tamao mximo de las cadenas tanto de entrada como de salida.
#define ANA_MAX_CADENA      1024

// Definicin de tipos de datos.
#define ANA_TIPO_NUMERO     1
#define ANA_TIPO_TEXTO      2

// Definicin de errores.
// **** Errores sintcticos
#define ANA_ERROR_NOERROR           0    // No hay error.
#define ANA_ERROR_NOOPERADOR        100 // Se esperaba un operador.
#define ANA_ERROR_NONUMERICO        200 // Se esperaba un valor numrico.
#define ANA_ERROR_NOPARENTESIS      300 // Se esperaba un parntesis cerrado.
#define ANA_ERROR_NOCIERREFUNCION   400 // Se esperaba un parntesis de cierre de funcin.
#define ANA_ERROR_NOOPERANDO        500 // Se esperaba un operando.
#define ANA_ERROR_NOSEPARADOR       600 // Se esperaba un separador de listas ; .
#define ANA_ERROR_TIPOOPERANDOS     700 // Los operandos son de distinto tipo.
#define ANA_ERROR_CARACTERNOVALIDO  800 // Se ha encontrado un carcter no valido.
// Estos dos ltimos valores deben ser activados por el programador en las
// funciones TPedirVariable y TPedirFuncion.
#define ANA_ERROR_NOVARIABLE        1000 // No es una variable vlida.
#define ANA_ERROR_NOFUNCION         1100 // No es una funcin vlida.
// **** Errores semnticos
#define ANA_ERROR_DIVISION          1200 // Se ha producido una divisin por cero.  


// definicin del bloque de datos.
typedef struct{
    double Numero;
    char Texto[ANA_MAX_CADENA];
    BYTE Tipo;
    int Error;
    int PosError;
} BLOQUEDEDATOS;


// Definicin de funciones callback.
#ifdef _ANA_PARA_CPP
typedef void _fastcall (__closure *TPedirVariable)(char *Variable,
    BLOQUEDEDATOS *D);
typedef void _fastcall (__closure *TPedirFuncion)(char *Funcion,
    BLOQUEDEDATOS *Parametros, int N, BLOQUEDEDATOS *R);
#else
typedef void __stdcall (*TPedirVariable)(char *Variable,
    BLOQUEDEDATOS *D);
typedef void __stdcall (*TPedirFuncion)(char *Funcion,
    BLOQUEDEDATOS *Parametros, int N, BLOQUEDEDATOS *R);
#endif

// Estructura de datos de contexto. Se utiliza esta estructura ya que al no
// existir instancias en C, se pueda llamar varias veces a estas funciones
// simplemente cambiando los datos de contexto. Esto se hace sobre todo cuando
// se llama desde una clase en C++, ya que varias instancias llamarn a las
// mismas funciones pero con contextos diferentes.
typedef struct {
        int Lookahead; // Token actual.
        int Poserror, P_Error; // Posicin que se est analizando en el buffer
                               // de entrada y posicin del token que se est
                               // analizando.
        char *p; // Apunta al carcter de entrada que se est analizando.
        char Buffer[ANA_MAX_CADENA+1];  // Solo se pueden analizar expresiones de como
                           // mximo ANA_MAX_CADENA caracteres.
        char LexCadena[ANA_MAX_CADENA+1]; // Cadena que ha cazado el analizador lxico.
        double LexValor; // Valor de la cadena que ha cazado el analizador
                         //lxico.
        char SimboloDecimal, SimboloMillar;

        TPedirVariable AlPedirVariable;
        TPedirFuncion AlPedirFuncion;
} ANADATOSDECONTEXTO;

//---------------------------------------------------------------------------
#endif
